Attribute VB_Name = "Math"
Public Type VECTOR2D
    X As Single
    Y As Single
End Type

Public Function V2Sum(a As VECTOR2D, b As VECTOR2D) As VECTOR2D
    V2Sum.X = a.X + b.X
    V2Sum.Y = a.Y + b.Y
End Function

Public Function V2Sub(a As VECTOR2D, b As VECTOR2D) As VECTOR2D
    V2Sub.X = a.X - b.X
    V2Sub.Y = a.Y - b.Y
End Function

Public Sub V2Add(a As VECTOR2D, b As VECTOR2D)
    a.X = a.X + b.X
    a.Y = a.Y + b.Y
End Sub
Public Function V2Scale(v As VECTOR2D, ByVal factor As Single) As VECTOR2D
    V2Scale.X = v.X * factor
    V2Scale.Y = v.Y * factor
End Function

Public Function V2Length(v As VECTOR2D) As Single
    V2Length = Sqr(v.X ^ 2 + v.Y ^ 2)
End Function

Public Function V2Normalize(v As VECTOR2D) As VECTOR2D
    On Error Resume Next
    V2Normalize = V2Scale(v, 1 / V2Length(v))
End Function


Public Function V2DotProduct(a As VECTOR2D, b As VECTOR2D) As Single
    V2DotProduct = a.X * b.X + a.Y * b.Y
End Function

Public Sub V2ProjTangNormScalar(v As VECTOR2D, dir As VECTOR2D, ByRef vsTang As Single, vsNorm As Single)
    vsTang = v.X * dir.X + v.Y * dir.Y ' |v|*|d|*cos(v^d)     // |d| = 1
    vsNorm = v.X * dir.Y - v.Y * dir.X ' |v|*|d|*sin(v^d)     // |d| = 1
End Sub

Public Function V2RotateCW90(v As VECTOR2D) As VECTOR2D
    V2RotateCW90.X = v.Y
    V2RotateCW90.Y = -v.X
End Function

