VERSION 5.00
Begin VB.Form Form1 
   BackColor       =   &H00000000&
   Caption         =   "Form1"
   ClientHeight    =   7425
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   14685
   LinkTopic       =   "Form1"
   MousePointer    =   2  'Cross
   ScaleHeight     =   7425
   ScaleWidth      =   14685
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer WorldTick 
      Interval        =   5
      Left            =   7875
      Top             =   3795
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type POINT2D
    v As VECTOR2D
End Type

Private Enum MOVING_OBJECT_PHASE
    Idling
    Accelerating
    Moving
    Decelerating
End Enum

Private Type SHIP_CLASS
    TangentialSpeedLimit    As Single
    TangentialAcceleration  As Single
    TangentialDeceleration  As Single
    NormalAcceleration      As Single
End Type

Private Type SHIP_UNIT
    iClassIndex         As Long
    bIsZombieUnit       As Boolean
    CurrentPos          As POINT2D
    TargetPos           As POINT2D
    Speed               As VECTOR2D
    MovementPhase       As MOVING_OBJECT_PHASE
    VisualGizmo         As Shape
End Type

Private ShipClassesTable() As SHIP_CLASS
Private ShipUnitsTable()   As SHIP_UNIT

Const tolerance_radius = 7.5

Private Sub InitShipClass(ByRef sc As SHIP_CLASS, ByVal tngSpeedLim As Single, ByVal tngAccDec As Single, ByVal nrmAcc As Single)
    sc.TangentialSpeedLimit = tngSpeedLim
    sc.TangentialAcceleration = tngAccDec
    sc.TangentialDeceleration = tngAccDec
    sc.NormalAcceleration = nrmAcc
End Sub

Private Sub InitShipUnit(ByRef su As SHIP_UNIT, ByVal iShipCls As Long, ByVal px As Single, ByVal py As Single)
    Static gizmo_next_index As Long
    Dim gizmo_name As String
    
    su.iClassIndex = iShipCls
    su.CurrentPos.v.X = px
    su.CurrentPos.v.Y = py
    su.TargetPos = su.CurrentPos
    
    gizmo_name = "gizm" + CStr(gizmo_next_index)
    Me.Controls.Add "VB.Shape", gizmo_name
    gizmo_next_index = gizmo_next_index + 1
    Set su.VisualGizmo = Me.Controls(gizmo_name)
    With su.VisualGizmo
        .Shape = vbShapeCircle
        .BorderWidth = 2
        .BorderColor = RGB(0, 255, 0)
        .Width = 340
        .Height = 340
    End With
End Sub


Private Sub Form_Initialize()
    Randomize Timer
    
    ReDim ShipClassesTable(1 To 1)
    InitShipClass ShipClassesTable(1), 5000, 7000, 9000
    
    ReDim ShipUnitsTable(1 To 1)
    InitShipUnit ShipUnitsTable(1), 1, _
            RandFromRng(ScaleWidth * 0.1, ScaleWidth * 0.9), _
            RandFromRng(ScaleHeight * 0.1, ScaleHeight * 0.9)
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    ShipUnitsTable(1).TargetPos.v.X = X
    ShipUnitsTable(1).TargetPos.v.Y = Y
End Sub

Private Sub WorldTick_Timer()
    ProcessPhysTick
    Render
End Sub

Public Sub ProcessPhysTick()
    Static prevTimer As Single
    Static curTimer  As Single
    Dim dt As Single
    
    curTimer = Timer
    
    If prevTimer = 0 Then
        prevTimer = curTimer
        Exit Sub
    Else
        dt = curTimer - prevTimer
        prevTimer = curTimer
    End If
    
    Dim i As Long
    
    For i = LBound(ShipUnitsTable) To UBound(ShipUnitsTable)
        With ShipUnitsTable(i)
            Dim direction As VECTOR2D
            Dim normDir   As VECTOR2D
            Dim dist      As Single
            
            direction = V2Sub(.TargetPos.v, .CurrentPos.v)
            dist = V2Length(direction)
            
            If dist <= tolerance_radius And V2Length(V2Scale(.Speed, dt)) <= tolerance_radius Then
                .Speed.X = 0: .Speed.Y = 0
                .MovementPhase = Idling
            Else
                normDir = V2Normalize(direction)
                
                '
                '       :
                '  1.     ,      ,
                '        ,     
                '     :  ()   ().
                '  2.    ,    
                '      .    ,  
                '           .
                '  3.      .
                '  4.    ,    
                '     ,  ,    .   
                '        ,       ,
                '      overshoot.
                '
                
                Dim tang_speed As Single
                Dim side_speed As Single
                
                V2ProjTangNormScalar .Speed, normDir, tang_speed, side_speed
              
                
                
                If tang_speed < 0 Then
                    '
                    '     .    .
                    '
                    If .MovementPhase <> Accelerating Then Debug.Print "Accelerating!"
                    .MovementPhase = Accelerating
                    
                ElseIf dist - ((tang_speed ^ 2) / (2 * ShipClassesTable(.iClassIndex).TangentialDeceleration)) - tolerance_radius * 1.6 <= 0 Then
                    '
                    '      .     
                    '   ,   .   ,
                    '
                    If .MovementPhase <> Decelerating Then Debug.Print "Decelerating!"
                    .MovementPhase = Decelerating
                    
                ElseIf tang_speed >= ShipClassesTable(.iClassIndex).TangentialSpeedLimit Then
                    '
                    '      
                    '
                    If .MovementPhase <> Moving Then Debug.Print "Speed limit!"
                    .MovementPhase = Moving
                Else
                    '
                    '  
                    '
                    If .MovementPhase <> Accelerating Then Debug.Print "Accelerating!"
                    .MovementPhase = Accelerating
                End If
                
                
                Dim d_tang_speed As VECTOR2D
                Dim d_side_speed As VECTOR2D
                
                Select Case .MovementPhase
                    Case Accelerating
                        d_tang_speed = V2Scale(normDir, ShipClassesTable(.iClassIndex).TangentialAcceleration * dt)
                    Case Decelerating
                        d_tang_speed = V2Scale(normDir, -1 * ShipClassesTable(.iClassIndex).TangentialDeceleration * dt)
                End Select
                
                
                Dim ortoDir As VECTOR2D
                ortoDir = V2RotateCW90(normDir)
                
                If Abs(side_speed * dt) > tolerance_radius Then
                    d_side_speed = V2Scale(ortoDir, -1 * ShipClassesTable(.iClassIndex).NormalAcceleration * dt * Sgn(side_speed))
                Else
                    d_side_speed = V2Scale(ortoDir, -side_speed)
                End If
                
                V2Add .Speed, d_tang_speed
                V2Add .Speed, d_side_speed
                Me.Caption = V2Length(.Speed)
            End If
            
            
        
            V2Add .CurrentPos.v, V2Scale(.Speed, dt)
        End With
    Next i
End Sub

Public Sub Render()
    Dim i As Long
    For i = LBound(ShipUnitsTable) To UBound(ShipUnitsTable)
        With ShipUnitsTable(i)
            .VisualGizmo.Move .CurrentPos.v.X - .VisualGizmo.Width / 2, _
                              .CurrentPos.v.Y - .VisualGizmo.Height / 2
            If .bIsZombieUnit <> Not .VisualGizmo.Visible Then
                .VisualGizmo.Visible = Not .bIsZombieUnit
            End If
        End With
    Next i
End Sub

Private Function RandFromRng(ByVal start As Single, ByVal ending As Single) As Single
    RandFromRng = start + (ending - start) * Rnd
End Function



